//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define USERQUIT_SIGPIPE 1
#define USERQUIT_QUIT 2
#define USERQUIT_EOF 3
#define USERQUIT_TIMEOUT 4

struct weircd_user_floodprotect {
	int floodpoints; //one gets substracted every second and some added for various actions
	int sendlines; //one point added for every sent line and two substracted every second
};
struct weircd_user {
	char* ip[16];
	int pleaseremove;
	long pleaseremove_time;
	long logintime;
	int socket;
	struct weircd_user_floodprotect floodprotect;
	unsigned char nickname[COMPILEOPTION_MAXNICKLEN + 1];
};

void* userpointers[COMPILEOPTION_MAXUSERS];
int userslotcount = 0;

void weircdUserInit() {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		userpointers[r] = NULL;
		r += 1;
	}
}
void userAdd(int socket) {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] == NULL) {
			userpointers[r] = malloc(sizeof(struct weircd_user));
			memset(userpointers[r], 0, sizeof(struct weircd_user));
			((struct weircd_user*)userpointers[r])->socket = socket;
			return;
		}
		r += 1;
	}
	close(socket);//adding failed!
	
}
struct weircd_user* ubn(const unsigned char* nickname) {//UserByName()
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
	
		r += 1;
	}
}
int uSocket(int uid) {
	return ((struct weircd_user*)userpointers[uid])->socket;
}
void userQuit(int uid, int reason) {
	
}
